<template>
  <section class="main-content">

    <breadcrumb separator="›">
      <breadcrumb-item label="Início" to="/admin"></breadcrumb-item>
    </breadcrumb>

    <nav class="nav" style="margin-bottom: 50px">
      <div class="nav-left">
        <div class="nav-item">
          <h2 class="title">Adicione mídias à Iniciativa</h2>
        </div>
      </div>
    </nav>

    <div class="columns">
      <div class="column is-6 is-offset-3">
        <div v-if="showinfo">
          <div class="control">
            <h3>{{getCurrentIniciativa.title}}</h3>
          </div>
        </div>
        <div class="control">
          <tabs type="boxed">
            <tab-item label="Imagens">
              <ImageUpload
                accepttypes="image/*"
                @hasnoimages="withNoImages"
                @hasimages="withImages"
                fileSizeLimit="10MB"
                :solutionId="getCurrentIniciativa.id"
                :max="1000"
                :cover-id="getCoverId"
              />
            </tab-item>
            <tab-item label="Vídeos">
              <UrlAttach
                mediatype="video"
                :solutionId="getCurrentIniciativa.id"
                :sources="['https://www.youtube.com/', 'https://youtu.be', 'https://vimeo.com/']"
              />
            </tab-item>
            <tab-item label="Documentos">
              <FileUpload
                :max="1000"
                :solutionId="getCurrentIniciativa.id"
                fileSizeLimit="10MB"
                accepttypes="application/pdf, text/plain, application/vnd.ms-excel,
                application/msword, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet,
                application/vnd.openxmlformats-officedocument.wordprocessingml.document,
                application/vnd.openxmlformats-officedocument.presentationml.presentation,
                application/vnd.ms-powerpoint"
              />
            </tab-item>
            <tab-item label="Áudios">
              <UrlAttach
                mediatype="audio"
                :solutionId="getCurrentIniciativa.id"
                :sources="['https://soundcloud.com/']"
              />
            </tab-item>
            <tab-item label="Links">
              <UrlAttach
                mediatype="link"
                :solutionId="getCurrentIniciativa.id"
              />
            </tab-item>
          </tabs>
          
        </div>
        <div class="has-text-right">
          <button
            class="button is-primary"
            @click="save()"
            :title="btnTitle"
            :disabled="btnDisable"
          >{{btnLabel}}</button>
        </div>
      </div>
    </div>

  </section>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex'
  import FileUpload from './file-upload-component.vue'
  import ImageUpload from './image-upload-component.vue'
  import UrlAttach from './url-attach-component.vue'

  import { getInitiative } from '../api/initiative.service.js'

  export default {
    name: 'AdicionarIniciativaCapa',

    components: { FileUpload, ImageUpload, UrlAttach },

    data () {
      return {
        btnLabel: 'Concluir',
        showinfo: false,
        btnDisable: true,
        btnTitle: "Você precisa enviar pelo menos uma imagem"
      }
    },

    methods: {
      ...mapActions(['saveCurrentIniciativa']),
      showSuccess(file) {
        console.log('A file was successfully uploaded')
      },
      withImages() {
        this.btnTitle = "";
        this.btnDisable = false;
      },
      withNoImages() {
        this.btnTitle = "Você precisa enviar pelo menos uma imagem";
        this.btnDisable = true;
      },
      save() {
           this.$router.push(`/admin/iniciativas`);
      }
    },

    computed: {
      ...mapGetters(['getCurrentIniciativa']),
      getCoverId () {
        if (this.getCurrentIniciativa.coverImage && this.getCurrentIniciativa.coverImage.id) {
          return this.getCurrentIniciativa.coverImage.id
        }
        return ""
      }
    },

    created() {
      if (this.$route.params.action === 'editar') {
        this.btnLabel = 'Retornar para listagem'
      }
      getInitiative(this.$route.params.id)
        .then(
          success => {
            this.saveCurrentIniciativa({ data: success.data, onlyStore: true });
            this.showinfo = true;
          },
          error => {

          }
        )
    }
  }
</script>
